# Submit a data query

Submits a [data query](https://docs.zuora.com?resourceId=platform-data-query-overview) to be executed by Zuora, creating a new query job. Use the [Retrieve a data query job](https://developer.zuora.com/v1-api-reference/api/operation/GET_DataQueryJob/) endpoint to monitor the job status and access the results once complete.
**Note:** The request must include the `Content-Type: application/json` header. If this header is missing, the request will fail with the following error:   `{"code":415,"message":"HTTP 415 Unsupported Media Type"}`

Endpoint: POST /query/jobs
Version: 2026-10-30
Security: bearerAuth

## Security:

  - `bearerAuth` (unknown)
    http bearer

## Header parameters:

  - `Idempotency-Key` (string)
    Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. 

With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.

  - `Accept-Encoding` (string)
    Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.

  - `Content-Encoding` (string)
    Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

  - `Zuora-Entity-Ids` (string)
    An entity ID. If you have [Zuora Multi-entity](https://docs.zuora.com?resourceId=platform-multi-entity-overview) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

  - `Zuora-Org-Ids` (string)
    Comma separated IDs. If you have Zuora Multi-Org enabled,
you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

  - `Content-Type` (string, required)
    Specifies the media type of the request payload. You must include the `Content-Type: application/json` header when submitting a data query.

## Request fields (application/json):

  - `columnSeparator` (string)
    The column separator. Only applicable if the `outputFormat` is `DSV`.

  - `compression` (string, required)
    Specifies whether Zuora compresses the query results.
    Enum: "NONE", "GZIP", "ZIP"

  - `encryptionKey` (string)
    Base-64 encoded public key of an RSA key-pair. 

Note that Data Query only supports 1024-bit RSA keys.

If you set this field, Zuora encrypts the query results using the provided public key. You must use the corresponding private key to decrypt the query results.

  - `output` (object, required)
    Additional information about the query results.

  - `output.target` (string, required)
    Set this field to `S3`.
    Enum: "S3"

  - `outputFormat` (string, required)
    Specifies the format of the query results.
* `JSON` - Each row in the query results will be a JSON object. The format of the query result file is [JSON Lines](http://jsonlines.org/).
* `CSV` - Each row in the query results will be a comma-separated list of values.
* `TSV` - Each row in the query results will be a tab-separated list of values.
* `DSV` - Pass any character as your custom delimiter into the `columnSeparator` field.
    Enum: "JSON", "CSV", "TSV", "DSV"

  - `query` (string, required)
    The query to perform. See [SQL Queries in Data Query](https://docs.zuora.com?resourceId=platform-sql-queries-in-data-query) for more information.

  - `readDeleted` (boolean)
    Indicates whether the query will retrieve only the deleted record. If `readDeleted` is set to `false` or it is not included in the request body, the query will retrieve only the non-deleted records. If it is set to `true`, only the deleted records will be retrieved.
If you select the `deleted` column in the `query` field, both non-deleted and deleted records will be retrieved regardless of the value in the `readDeleted` field.
Note that Data Query is subject to Zuora Data Retention Policy. The retention period of deleted data is 30 days. You can only retrieve deleted data for 30 days through Data Query.

  - `sourceData` (string)
    Specify the source that data queries run against:
* `LIVE` represents the live transactional databases at Zuora (Data Query Live).
* `WAREHOUSE` represents Zuora Warehouse, which has better performance and fewer limitations than the live transactional database. This option is available only if you have the Zuora Warehouse feature enabled in your tenant. For more information, see Zuora Warehouse. If this option is selected, you can specify warehouse size in `warehouseSize`.

If this field is not specified, the default value `LIVE` will be used.
    Enum: "LIVE", "WAREHOUSE"

  - `useIndexJoin` (boolean)
    Indicates whether to use Index Join. Index join is useful when you have a specific reference value in your WHERE clause to index another large table by. See [Use Index Join](https://docs.zuora.com?resourceId=platform-data-query-practices) for more information.

  - `warehouseSize` (string)
    Specify the size of Zuora Warehouse. This field is available only if the `sourceData` is `WAREHOUSE`.
If this field is not specified or set to `NULL`, the default value `xsmall` will be used.
    Enum: "xsmall", "NULL"

## Response 200:

  - `200` (unknown)
    OK

## Response 200 fields (application/json):

  - `data` (object)
    A data query job.

  - `data.createdBy` (string)
    The query job creator's Id.

  - `data.id` (string)
    Internal identifier of the query job.

  - `data.query` (string)
    The query that was submitted.

  - `data.remainingRetries` (integer)
    The number of times that Zuora will retry the query if Zuora is unable to perform the query.

  - `data.sourceData` (string)
    Indicates the source that data queries run against:
* `LIVE` represents the live transactional databases at Zuora (Data Query Live).
* `WAREHOUSE` represents Zuora Warehouse, which has better performance and fewer limitations than the live transactional database. For more information, see Zuora Warehouse.

  - `data.updatedOn` (string)
    Date and time when the query job was last updated, in ISO 8601 format.

  - `data.useIndexJoin` (boolean)
    Indicates whether to use Index Join. See Index Join for more information.

  - `data.dataFile` (string)
    The URL of the query results. Only applicable if the value of the `queryStatus` field is `completed`.

  - `data.outputRows` (integer)
    The number of rows the query results. Only applicable if the value of the `queryStatus` field is `completed`.

  - `data.processingTime` (integer)
    Processing time of the query job, in milliseconds. Only applicable if the value of the `queryStatus` field is `completed`.

  - `data.queryStatus` (string)
    Status of the query job.
* `submitted` - query submitted to query service for processing
* `accepted` - query accepted by the query service
* `in_progress` - query executed by the query service
* `completed` - query execution completed by the query service
* `failed` - query unable to be processed by the query service
* `cancelled` - query cancelled by the user

If the value of this field is `completed`, the `dataFile` field contains the location of the query results.
If the value of this field is `accepted` or `in_progress`, you can use [Cancel a data query job](#operation/DELETE_DataQueryJob) to prevent Zuora from performing the query. Zuora then sets the status of the query job to `cancelled`.
    Enum: "submitted", "accepted", "in_progress", "completed", "failed", "cancelled"

## Response 200 headers (application/json):

  - `Content-Encoding` (string)
    This header is returned if you specify the `Accept-Encoding: gzip` request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
- `application/json`
- `application/xml`
- `text/html`
- `text/csv`
- `text/plain`

  - `RateLimit-Limit` (string)
    The request limit quota for the time window closest to exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Remaining` (number)
    The number of requests remaining in the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Reset` (number)
    The number of seconds until the quota resets for the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `Zuora-Request-Id` (string)
    The Zuora internal identifier of the API call. You cannot control the value of this header.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. 
If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. 
Otherwise, Zuora does not set this header.

## Response 400:

  - `400` (unknown)
    Bad Request

## Response 400 fields (application/json):

  - `code` (integer)
    Error code.

  - `message` (string)
    Error message.

## Response 400 headers (application/json):

  - `Content-Encoding` (string)
    This header is returned if you specify the `Accept-Encoding: gzip` request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
- `application/json`
- `application/xml`
- `text/html`
- `text/csv`
- `text/plain`

  - `RateLimit-Limit` (string)
    The request limit quota for the time window closest to exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Remaining` (number)
    The number of requests remaining in the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Reset` (number)
    The number of seconds until the quota resets for the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `Zuora-Request-Id` (string)
    The Zuora internal identifier of the API call. You cannot control the value of this header.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. 
If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. 
Otherwise, Zuora does not set this header.

## Response 415:

  - `415` (unknown)
    Unsupported Media Type. This error is returned when the request is missing the required `Content-Type: application/json` header.

## Response 415 fields (application/json):

  - `code` (integer)
    Error code.

  - `message` (string)
    Error message.

## Response 200 examples:

  - `response` (unknown)

## Response 400 examples:

  - `response` (unknown)

## Response 415 examples:

  - `response` (unknown)

